// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_MESH_SHAPE_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_MESH_SHAPE_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreInitializers();
}

namespace exotica
{

class MeshShapeInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() { return "exotica/MeshShape"; }

    MeshShapeInitializer() : InitializerBase(),
        Type( "Mesh") ,
        Color( Eigen::Vector4d::Zero()) ,
        Scale( Eigen::Vector3d::Ones()) 
    {
    }

    MeshShapeInitializer( std::string _MeshFilePath, std::string _Type =  "Mesh", Eigen::Vector4d _Color =  Eigen::Vector4d::Zero(), Eigen::Vector3d _Scale =  Eigen::Vector3d::Ones()) : InitializerBase(),
        MeshFilePath(_MeshFilePath) ,
        Type(_Type) ,
        Color(_Color) ,
        Scale(_Scale) 
    {
    }

    MeshShapeInitializer(const Initializer& other) : MeshShapeInitializer()
    {
        if (other.HasProperty("MeshFilePath")) { const Property& prop = other.properties_.at("MeshFilePath"); if(prop.IsSet()) {MeshFilePath = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("Type")) { const Property& prop = other.properties_.at("Type"); if(prop.IsSet()) {Type = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("Color")) { const Property& prop = other.properties_.at("Color"); if(prop.IsSet()) {Color = prop.IsStringType()?ParseVector<double,4>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::Vector4d>(prop.Get());} }
        if (other.HasProperty("Scale")) { const Property& prop = other.properties_.at("Scale"); if(prop.IsSet()) {Scale = prop.IsStringType()?ParseVector<double,3>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::Vector3d>(prop.Get());} }
    }

    virtual ~MeshShapeInitializer()
    {
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)MeshShapeInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("MeshFilePath") || !other.properties_.at("MeshFilePath").IsSet()) ThrowPretty("Initializer MeshShapeInitializer requires property MeshFilePath to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("MeshFilePath", Property("MeshFilePath", true, boost::any(MeshFilePath)));
        ret.properties_.emplace("Type", Property("Type", false, boost::any(Type)));
        ret.properties_.emplace("Color", Property("Color", false, boost::any(Color)));
        ret.properties_.emplace("Scale", Property("Scale", false, boost::any(Scale)));
        return ret;
    }

    std::string MeshFilePath;
    std::string Type;
    Eigen::Vector4d Color;
    Eigen::Vector3d Scale;
};

}

#include <exotica_core/exotica_core_initializers_numerator.h>


#endif